local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

local SkillName, icon, SkillLevel, numSkills, SkillMaxLevel, SkillModifier, specIndex, specOffset
local profession, ProfAbbr, BonusRace, racial;
local lastPanel;
local SkillCap = 800;
local race = E.myrace
local _hex
local red = "|cffc74040"
local orange = "|cffda8c4f"

--[[local v, b, d, t = GetBuildInfo()
if b == "19103" then
	SkillCap = 600
else
	SkillCap = 700
end ]]

local function GetBonusRace(prof, num)
	if prof == "Alchemy" then
		BonusRace = "Goblin"
		Racial = 15
	elseif prof == "Enchanting" then
		BonusRace = "Blood Elf"
		Racial = 10
	elseif prof == "Engineering" then
		BonusRace = "Gnome"
		Racial = 15
	elseif prof == "Jewelcrafting" then
		BonusRace = "Draenei"
		Racial = 10
	elseif prof == "Skinning" then
		BonusRace = "Worgen"
		Racial = 15
	else
		BonusRace = nil
		Racial = 0
	end
	
	if num == 1 then return BonusRace
	elseif num == 2 then return Racial
	end
end

local function GetMaxSkillName(Name, maxSkill)
	local r = 0
	if race == GetBonusRace(Name, 1) then r = GetBonusRace(Name, 2) end
	if maxSkill == (75+r) then return "Apprentice"
	elseif maxSkill == (150+r) then return "Journeyman"
	elseif maxSkill == (225+r) then return "Expert"
	elseif maxSkill == (300+r) then return "Artisan"
	elseif maxSkill == (375+r) then return "Master"
	elseif maxSkill == (450+r) then return "Grand Master"
	elseif maxSkill == (525+r) then return "Illustrious Grand Master"
	elseif maxSkill == (600+r) then return "Zen Master"
	elseif maxSkill == (700+r) then return "Draenor Master"
	elseif maxSkill == (800+r) then return "Legion Master"
	else return "N/A"
	end
end

local function GetSpecialization(prof, skill, index, offset, num)
	local spec, specid, specIcon
	if prof == "Alchemy" then
		if index == 2 then
			spec = "Elixir Master"
			specid = 28677
			specIcon = "inv_relics_totemoflife"
		elseif index == 3 then
			spec = "Potion Master"
			specid = 28675
			specIcon = "inv_relics_totemoflife"
		elseif index == 4 then
			spec = "Transmution Master"
			specid = 28672
			specIcon = "inv_relics_totemoflife"
		else
			specid = 0
			if skill >= 475 then
				spec = "Learnable"
			else
				spec = "Learnable @ 475"
			end
		end
	elseif prof == "Engineering" then
		if offset == 1 then 
			spec = "Goblin Engineer"
			specid = 20222
			specIcon = "spell_fire_selfdestruct"
		elseif offset == 2 then
			spec = "Gnomish Engineer"
			specid = 20219
			specIcon = "inv_gizmo_02"
		else 
			specid = 0
			if skill >= 200 then
				spec = "Learnable"
			else
				spec = "Learnable @ 200"
			end
		end
	else
		spec = "N/A"
	end
	if num == 1	then return spec
	elseif num == 2 then return specid
	elseif num == 3 then return format('|T%s:14:14:0:0:64:64:4:60:4:60|t', "Interface\\Icons\\"..specIcon)
	end
end

local function GetProfDesc(Name, Max)
	local id
	local r = 0
	if race == GetBonusRace(Name, 1) then r = GetBonusRace(Name, 2) end
	if Name == "Alchemy" then
		if Max == (75+r) then id = 2259
		elseif Max == (150+r) then id = 3101
		elseif Max == (225+r) then id = 3464
		elseif Max == (300+r) then id = 11611
		elseif Max == (375+r) then id = 28596
		elseif Max == (450+r) then id = 51304
		elseif Max == (525+r) then id = 80731
		elseif Max == (600+r) then id = 105206
		elseif Max == (700+r) then id = 156606
		elseif Max == (800+r) then id = 195095
		end
	elseif Name == "Blacksmithing" then
		if Max == 75 then id = 2018
		elseif Max == 150 then id = 3100
		elseif Max == 225 then id = 3538
		elseif Max == 300 then id = 9785
		elseif Max == 375 then id = 29844
		elseif Max == 450 then id = 51300
		elseif Max == 525 then id = 76666
		elseif Max == 600 then id = 110396
		elseif Max == 700 then id = 158737
		elseif Max == 800+r then id = 195097
		end
	elseif Name == "Enchanting" then
		if Max == (75+r) then id = 7411
		elseif Max == (150+r) then id = 7412
		elseif Max == (225+r) then id = 7413
		elseif Max == (300+r) then id = 13920
		elseif Max == (375+r) then id = 28029
		elseif Max == (450+r) then id = 51313
		elseif Max == (525+r) then id = 74258
		elseif Max == (600+r) then id = 110400
		elseif Max == (700+r) then id = 158716
		elseif Max == (800+r) then id = 195096
		end
	elseif Name == "Engineering" then
		if Max == (75+r) then id = 4036
		elseif Max == (150+r) then id = 4037
		elseif Max == (225+r) then id = 4038
		elseif Max == (300+r) then id = 12656
		elseif Max == (375+r) then id = 30350
		elseif Max == (450+r) then id = 51306
		elseif Max == (525+r) then id = 82774
		elseif Max == (600+r) then id = 110403
		elseif Max == (700+r) then id = 158739
		elseif Max == (800+r) then id = 195112
		end
	elseif Name == "Herbalism" then
		if Max == 75 then id = 2366
		elseif Max == 150 then id = 2368
		elseif Max == 225 then id = 3570
		elseif Max == 300 then id = 11993
		elseif Max == 375 then id = 28695
		elseif Max == 450 then id = 50300
		elseif Max == 525 then id = 74519
		elseif Max == 600 then id = 110413
		elseif Max == 700 then id = 158745
		elseif Max == 800 then id = 195114
		end
	elseif Name == "Inscription" then
		if Max == 75 then id = 45357
		elseif Max == 150 then id = 45358
		elseif Max == 225 then id = 45359
		elseif Max == 300 then id = 45360
		elseif Max == 375 then id = 45361
		elseif Max == 450 then id = 45363
		elseif Max == 525 then id = 86008
		elseif Max == 600 then id = 110417
		elseif Max == 700 then id = 158748
		elseif Max == 800+r then id = 195115
		end
	elseif Name == "Jewelcrafting" then
		if Max == (75+r) then id = 25229
		elseif Max == (150+r) then id = 25230
		elseif Max == (225+r) then id = 28894
		elseif Max == (300+r) then id = 28895
		elseif Max == (375+r) then id = 28897
		elseif Max == (450+r) then id = 51311
		elseif Max == (525+r) then id = 73318
		elseif Max == (600+r) then id = 110420
		elseif Max == (700+r) then id = 158750
		elseif Max == (800+r) then id = 195116
		end
	elseif Name == "Leatherworking" then
		if Max == 75 then id = 2108
		elseif Max == 150 then id = 3104
		elseif Max == 225 then id = 3811
		elseif Max == 300 then id = 10662
		elseif Max == 375 then id = 32549
		elseif Max == 450 then id = 51302
		elseif Max == 525 then id = 81199
		elseif Max == 600 then id = 110423
		elseif Max == 700+r then id = 158752
		elseif Max == 800+r then id = 195119
		end
	elseif Name == "Mining" then
		if Max == 75 then id = 2575
		elseif Max == 150 then id = 2576
		elseif Max == 225 then id = 3564
		elseif Max == 300 then id = 10248
		elseif Max == 375 then id = 29354
		elseif Max == 450 then id = 50310
		elseif Max == 525 then id = 74517
		elseif Max == 600 then id = 102161
		elseif Max == 700+r then id = 158754
		elseif Max == 800+r then id = 195122
		end
	elseif Name == "Skinning" then
		if Max == (75+r) then id = 8613
		elseif Max == (150+r) then id = 8617
		elseif Max == (225+r) then id = 8618
		elseif Max == (300+r) then id = 10768
		elseif Max == (375+r) then id = 32678
		elseif Max == (450+r) then id = 50305
		elseif Max == (525+r) then id = 74522
		elseif Max == (600+r) then id = 102216
		elseif Max == (700+r) then id = 158756
		elseif Max == (800+r) then id = 195125
		end
	elseif Name == "Tailoring" then
		if Max == 75 then id = 3908
		elseif Max == 150 then id = 3909
		elseif Max == 225 then id = 3910
		elseif Max == 300 then id = 12180
		elseif Max == 375 then id = 26790
		elseif Max == 450 then id = 51309
		elseif Max == 525 then id = 75156
		elseif Max == 600 then id = 110426
		elseif Max == 700 then id = 158758
		elseif Max == 800 then id = 195126
		end
	end
	if id then return GetSpellDescription(id)
	else return "N/A"
	end
end

local function GetProfPerkName(prof)
	local perk
	if prof == "Alchemy" then
		perk = "Mixology"
	elseif prof == "Jewelcrafting" then
		perk = "Gem Perfection"
	elseif prof == "Tailoring" then
		perk = "Cloth Scavenging"
	else
		perk = "N/A"
	end
	return perk
end

local function GetProfPerkDesc(Name, Level)
	local id;
	local val;
	if Name == "Mixology" then 
		id = 53042
		val = nil
	elseif Name == "Gem Perfection" then
		id = 55534
--		id = 55790
		val = nil
	elseif Name == "Northern Cloth Scavenging" then
		if Level >= 325 then id = 59390
		end
	end
	
	if id then return string.gsub(GetSpellDescription(id), "$s1", format("%d", val))
	else return "N/A"
	end
end

local function OnEvent(self, event, ...)
	local prof1, prof2 = GetProfessions()
	local profs = {prof1, prof2}
	if prof2 ~= nil then
		local name, texture, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof2)
		profession, SkillName = name
		icon = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', texture)
		SkillLevel = rank
		SkillMaxLevel = maxRank
		numSkills = numSpells
		if rankModifier == nil or rankModifier == 0 then
			SkillModifier = 0
		else
			SkillModifier = rankModifier
		end
		specIndex = specializationIndex
		specOffset = specializationOffset
		
		if SkillMaxLevel ~= nil then
			if (race == GetBonusRace(name, 1) and SkillLevel >= (SkillMaxLevel - GetBonusRace(name, 2)) - 25 and (SkillMaxLevel + GetBonusRace(name, 2)) < (SkillCap + GetBonusRace(name, 2))) or (SkillLevel >= SkillMaxLevel - 25 and SkillMaxLevel < SkillCap) then
				if SkillModifier > 0 then
					self.text:SetFormattedText("%s "..red.."(+%s)%s/%s|r", icon, SkillModifier, SkillLevel, SkillMaxLevel)
				else
					self.text:SetFormattedText("%s "..red.."%s/%s|r", icon, SkillLevel, SkillMaxLevel)
				end
			else -- otherwise keep bar default color
				if SkillModifier > 0 then
					self.text:SetFormattedText("%s ".._hex.."(+%s)%s/%s|r", icon, SkillModifier, SkillLevel, SkillMaxLevel)
				else
					self.text:SetFormattedText("%s ".._hex.."%s/%s|r", icon, SkillLevel, SkillMaxLevel)
				end
			end
		end
	else
		profession = nil 
		self.text:SetFormattedText("|cffFFFFFFProf 2:|r".._hex.." N/A|r");
	end

	if InCombatLockdown() == true then
		DT.tooltip:Hide()
	end
	
	lastPanel = self
end

local function OnEnter(self)
	local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b;
	if profession == nil then
		DT:SetupTooltip(self)
		DT.tooltip:AddLine("|cffFFFFFFYou have not learned a first primary profession|r", r2, g2, b2)
		DT.tooltip:Show()
	else
		DT:SetupTooltip(self)
		DT.tooltip:AddLine(format("%s %s", icon, profession), r1, g1, b1)
		DT.tooltip:AddLine(format("%s", GetProfDesc(profession, SkillMaxLevel)), r2, g2, b2, true);
		DT.tooltip:AddLine(" ");
		if GetProfPerkName(profession) ~= "N/A" then
			if profession == "Tailoring" and numSkills > 1 then
				DT.tooltip:AddLine(format("Perk: %s", GetProfPerkName(profession)), r1, g1, b1);
				DT.tooltip:AddLine(format("%s", GetProfPerkDesc(GetProfPerkName(profession), SkillLevel )), r2, g2, b2, true);
				DT.tooltip:AddLine(" ");
			end
		end
		
		DT.tooltip:AddDoubleLine("Skill Mastery:", GetMaxSkillName(profession, SkillMaxLevel), r1, g1, b1, r2, g2, b2);
		DT.tooltip:AddDoubleLine("Skill Cap:", format("%d", SkillCap), r1, g1, b1, r2, g2, b2);
		DT.tooltip:AddDoubleLine("Skill Level / Max Level:", format("%d / %d", SkillLevel, SkillMaxLevel), r1, g1, b1, r2, g2, b2);
		if race == GetBonusRace(profession, 1) and GetBonusRace(profession, 2) > 0 then
			DT.tooltip:AddDoubleLine("Racial Skill Bonus:", format("+%d", GetBonusRace(profession, 2)), r1, g1, b1, r2, g2, b2)
		end
		if SkillModifier > 0 then
			DT.tooltip:AddDoubleLine("Skill Modifier:", format("+%d", SkillModifier), r1, g1, b1, r2, g2, b2)
		end
		
		if GetSpecialization(profession, SkillLevel, _, _, 1) ~= "N/A" then
			if GetSpecialization(profession, SkillLevel, specIndex, specOffset, 2) ~= 0 then
				DT.tooltip:AddDoubleLine("Specialization:", GetSpecialization(profession, SkillLevel, specIndex, specOffset, 1), r1, g1, b1, r2, g2, b2);
				DT.tooltip:AddLine(" ");
				DT.tooltip:AddLine(format("%s %s", GetSpecialization(profession, SkillLevel, specIndex, specOffset, 3), GetSpecialization(profession, SkillLevel, specIndex, specOffset, 1)), r1, g1, b1);
				DT.tooltip:AddLine(format("%s", GetSpellDescription(GetSpecialization(profession, SkillLevel, specIndex, specOffset, 2))), r2, g2, b2, true);
			end
		end
		
		if profession ~= "Skinning" or profession ~= "Herbalism" then
			DT.tooltip:AddLine(" ");
			DT.tooltip:AddDoubleLine("Click:", "Toggle profession interface", r1, g1, b1, r2, g2, b2)
		end
		
		if InCombatLockdown() == true then
			DT.tooltip:Hide()
		--	return;
		else 
			DT.tooltip:Show()
		end
	end
end

local function OnClick(self)
	local p = ''
	if profession == "Skinning" then p = "Skinning Skills"
	elseif profession == "Herbalism" then p = "Herbalism Skills"
	elseif profession == "Mining" then p = "Mining Skills"
	else p = profession
	end 
	
--	if profession ~= "Skinning" or profession ~= "Herbalism" then
		CastSpellByName(p);
--	end
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
end
E["valueColorUpdateFuncs"][ValueColorUpdate] = true

DT:RegisterDatatext('Prof Primary 2', {"PLAYER_ENTERING_WORLD", "SKILL_LINES_CHANGED", "BAG_UPDATE"}, OnEvent, nil, OnClick, OnEnter)